function cdata = initialmatch_main( iparam, fparam, mparam )

% Load model image
disp('== Obtaining features from images...');

bShow = iparam.bShow;
nView = iparam.nView;

for j=1:nView
    viewInfo = extract_localfeatures_mcho( iparam.view(j).filePathName, fparam, bShow );
    viewInfo.fileName = iparam.view(j).fileName;  
    view(j) = viewInfo;
end
    
% eliminate patches for memory efficiency
view(1).patch = cell(0); 
view(1).desc_ref = [];
if iparam.bPair
    view(2).patch = cell(0);
    view(2).desc_ref = [];
end

% Find initial matches 
disp('== Performing initial matching of the feature regions');
[ matchInfo ]= make_initialmatches_mcho( view, mparam, bShow );
drawnow;
nInitialMatches = length(matchInfo);
disp( [ 'num of initial matches: ' num2str(nInitialMatches) ] );
% Find overlapping matches
disp('== Finding overlapping relations of the initial matches');
[ overlapMatrix ]= make_overlapMatrix2( view, cell2mat({ matchInfo.match }'), mparam );
nOverlap = sum(sum(overlapMatrix));
fprintf('- %d (%4.2f%%) overlapping pairs detected\n', nOverlap, nOverlap/nInitialMatches^2);
    
cdata.bPair = iparam.bPair;
cdata.nView = iparam.nView;
cdata.bReflective = mparam.bReflective;
cdata.nInitialMatches = nInitialMatches;
cdata.view = view;
cdata.matchInfo = matchInfo;
cdata.overlapMatrix = overlapMatrix;

cdata.mparam = mparam;
cdata.iparam = iparam;
cdata.fparam = fparam;